#!/bin/sh

awk -F '\t' '{print $1,$13}' GPL1261-14790.txt | sed '/^ID RefSeq Transcript ID$/,$ !d' > GPL1261_mRNA_annotation.txt
awk -F '\t' '{print $1,$11}' GPL1261-14790.txt | sed '/^ID Gene Symbol$/,$ !d' > GPL1261_gene_annotation.txt 
awk -F '\t' '{print $1,$12}' GPL1261-14790.txt | sed '/^ID ENTREZ_GENE_ID$/,$ !d' > GPL1261_GI_annotation.txt

sed '/^total\t8mer\t7mer-m8\t7mer-1A[\t ]*total\t8mer\t7mer-m8\t7mer-1A/,/Bioinformatics and Research Computing <http:\/\/jura.wi.mit.edu\/bio\/>/ !d' targetscan6.2_predictions_for_miR-223.html | grep -B 1 '^<http://www.ncbi.nlm.nih.gov/sites/entrez?Db=gene&Cmd=ShowDetailView&TermToSearch=' | grep -v '^\-\-$' | grep -v '^<http://www.ncbi.nlm.nih.gov/sites/entrez?Db=gene&Cmd=ShowDetailView&TermToSearch=' > targetscan_predicted_genes
sed '/^total\t8mer\t7mer-m8\t7mer-1A[\t ]*total\t8mer\t7mer-m8\t7mer-1A/,/Bioinformatics and Research Computing <http:\/\/jura.wi.mit.edu\/bio\/>/ !d' targetscan6.2_predictions_for_miR-223.html | grep -B 1 '^<http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?cmd=Search&db=nuccore&term==' | grep -v '^\-\-$' | grep -v '^<http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?cmd=Search&db=nuccore&term==' > targetscan_predicted_mRNAs
paste -d ' ' targetscan_predicted_genes targetscan_predicted_mRNAs > targetscan_predictions.dat
rm -f targetscan_predicted_genes targetscan_predicted_mRNAs

echo "Gene Representative_transcript Probesets_in_GPL1261" > Baek_vs_GPL1261.dat
nb_targets=`cat targetscan_predictions.dat | wc -l`
for i in `seq 1 $nb_targets`
do probesets=''
   gene=`head -$i targetscan_predictions.dat | tail -1 | awk '{print $1}'`
   mRNA=`head -$i targetscan_predictions.dat | tail -1 | awk '{print $2}'`
   grep -w $mRNA GPL1261_mRNA_annotation.txt > tmp_match
   if test `cat tmp_match | wc -l` -ne 0
   then probesets=`awk '{print $1}' tmp_match`
   else grep -w $gene GPL1261_gene_annotation.txt > tmp_match
        if test `cat tmp_match | wc -l` -eq 0
	then wget http://eutils.ncbi.nlm.nih.gov/entrez/eutils/esearch.fcgi?db=gene\&term=Mus+musculus[orgn]$gene'[gene]'
	     ID_list=`grep -P '^\t*<Id>' esearch.fcgi\?db\=gene\&term\=Mus+musculus\[orgn\]$gene''\[gene\] | sed 's|^\t*<Id>\([0-9]*\)</Id>|\1|'`
	     for ID in `echo $ID_list`
	     do grep -w $ID GPL1261_GI_annotation.txt > tmp_match
		if test `cat tmp_match | wc -l` -ne 0
		then probesets=`awk '{print $1}' tmp_match`
		else echo ""
		     echo " *** I can't find probesets for "$gene" (mRNA: "$mRNA") ***"
		     echo ""
		fi
	     done
	     rm -f esearch.fcgi?db=gene\&term=Mus+musculus[orgn]$gene'[gene]'
	else probesets=`awk '{print $1}' tmp_match`
	fi
   fi
   if test "$probesets" != ""
   then start=`head -$i targetscan_predictions.dat | tail -1`
        probesets=`echo $probesets | tr qwertyuiopasdfghjklzxcvbnm QWERTYUIOPASDFGHJKLZXCVBNM`
        echo $start "'"$probesets"'" >> Baek_vs_GPL1261.dat
   fi
done

echo "mutant1=read.table('GSM303277.txt',header=T)" > R_mRNA_fold-changes_in_Baek_2008
echo "mutant2=read.table('GSM303487.txt',header=T)" >> R_mRNA_fold-changes_in_Baek_2008
echo "mutant3=read.table('GSM303488.txt',header=T)" >> R_mRNA_fold-changes_in_Baek_2008
echo "wt1=read.table('GSM303489.txt',header=T)" >> R_mRNA_fold-changes_in_Baek_2008
echo "wt2=read.table('GSM303490.txt',header=T)" >> R_mRNA_fold-changes_in_Baek_2008
echo "wt3=read.table('GSM303491.txt',header=T)" >> R_mRNA_fold-changes_in_Baek_2008
echo "predicted_targets=read.table('Baek_vs_GPL1261.dat',header=T)" >> R_mRNA_fold-changes_in_Baek_2008
echo "means=c();medians=c()" >> R_mRNA_fold-changes_in_Baek_2008
echo "for (gene in predicted_targets\$Gene)" >> R_mRNA_fold-changes_in_Baek_2008
echo "{" >> R_mRNA_fold-changes_in_Baek_2008
echo "wt=c();mutant=c()" >> R_mRNA_fold-changes_in_Baek_2008
echo "for (probeset in strsplit(as.character(predicted_targets\$Probesets_in_GPL1261[predicted_targets\$Gene==gene]),' ')[[1]])" >> R_mRNA_fold-changes_in_Baek_2008
echo "{" >> R_mRNA_fold-changes_in_Baek_2008
echo "wt=c(wt,c(wt1\$VALUE.[wt1\$X.ID_REF..==probeset],wt2\$VALUE.[wt2\$X.ID_REF..==probeset],wt3\$VALUE.[wt3\$X.ID_REF..==probeset]))" >> R_mRNA_fold-changes_in_Baek_2008
echo "mutant=c(mutant,c(mutant1\$VALUE.[mutant1\$X.ID_REF..==probeset],mutant2\$VALUE.[mutant2\$X.ID_REF..==probeset],mutant3\$VALUE.[mutant3\$X.ID_REF..==probeset]))" >> R_mRNA_fold-changes_in_Baek_2008
echo "}" >> R_mRNA_fold-changes_in_Baek_2008
echo "means=c(means,mean(mutant)-mean(wt))" >> R_mRNA_fold-changes_in_Baek_2008
echo "medians=c(medians,median(mutant)-median(wt))" >> R_mRNA_fold-changes_in_Baek_2008
echo "}" >> R_mRNA_fold-changes_in_Baek_2008
echo "truc=list(predicted_targets\$Gene,means,medians)" >> R_mRNA_fold-changes_in_Baek_2008
echo "names(truc)=c('Gene','log2FC_means','log2FC_medians')" >> R_mRNA_fold-changes_in_Baek_2008
echo "sink('mRNA_fold-change_in_Baek_2008.dat')" >> R_mRNA_fold-changes_in_Baek_2008
echo "print(as.data.frame(truc))" >> R_mRNA_fold-changes_in_Baek_2008
echo "sink()" >> R_mRNA_fold-changes_in_Baek_2008

R CMD BATCH R_mRNA_fold-changes_in_Baek_2008
sed -i 's|^[0-9 ]*||' mRNA_fold-change_in_Baek_2008.dat
echo "Done. Results are in file 'mRNA_fold-change_in_Baek_2008.dat'."
